;(function(){
// wrapper javascript
"use strict";
var refTableau = 0;  // référence à l'objet DataTables
var NOTIF_TITRE = "Transfert de {1} : {2} !";
var NOTIF_TEXTE = "Le fichier {1} a bien été transféré.";
var NOTIF_DEVOIR = "Le document {1} a été distribué à {2} personne(s).";
var NOTIF_DEVOIR_ERR = "Le document {1} a été distribué à {2} personne(s), mais il y a eu des erreurs pour : {3}.";
var listeDestinataires = [];

jQuery(document).ready(function ($) {
    var max_upload_file_size = "10mb";          // taille max d'upload ajax par objet (sachant qu'il y a 2 upload)

    // Afficher l'onglet lorsqu'on clique sur un des menus (au début les onglets sont masqués)
    $(document).on("click", ".row-fluid", function(event){
        $(".tab-content").show();
    });
    // Cacher les onglets de démarrage start-onglet
    $(document).on("click", ".row-fluid", function(event){
        //on affiche le menu de navigation
        $(".nav.nav-pills").show();
        // on cache les boutons
        $(".row-fluid").hide();
        // on affiche les formulaires
        $(".tab-content").show();
        if ($(this).find("button").attr("id") == "btn-distribuer")
            $("#href-distribuer").click();
        if ($(this).find("button").attr("id") == "btn-ramassage")
            $("#href-gerer").click();
        if ($(this).find("button").attr("id") == "btn-liste")
            $("#href-historique").click();
    });

    // Distribuer
    $("#nomdev").val("");   // vidage du champ référence
    remplirGroupes();
    remplirFichTemp("devoir");
    remplirFichTemp("data");
    gestionActivationDistMail();

    // Gérer
    remplirListDevRamasser();
    remplirListDevRendre();
    gestionActivationRenMail();

    // Historique
    remplirTableauHistorique();

    // Suppression fichier temp
    $(document).on("click", ".suptemp", function(event){
        $("body").addClass("wait");
        var role = $(this).data("role");    // data ou devoir
        var fich = $(this).data("name");    // nom du fichier
        $.getJSON("documents/supprimerdoctemp/" + role + "/" + fich, function(data) {
            // Exemple de retour json : {"suppression": "La suppression de yoyo2000.gif a échoué."}
            if (data["reload"] !== undefined) {
                rechargerPage(data["reload"]); // la session a été perdue donc on recharge
            }else{
                afficherNotification("", "Suppression de fichier", data["suppression"]);
                remplirFichTemp(role);
            }
            $("body").removeClass("wait");
        });
    });

    // Vidage dossier temp
    $(document).on("click", ".vidtemp", function(event){
        $("body").addClass("wait");
        var role = $(this).data("role");    // data ou devoir
        $.getJSON("documents/viderdoctemp/" + role, function(data) {
            // Exemple de retour json : {"vidage": "Le dossier a été vidé."}
            if (data["reload"] !== undefined) {
                rechargerPage(data["reload"]); // la session a été perdue donc on recharge
            }else{
                afficherNotification("", "Effacement complet", data["vidage"]);
                remplirFichTemp(role);
            }
            $("body").removeClass("wait");
        });
    });

    // Suppression destinataire
    $(document).on("click", ".supdestinataire", function(event){
        var dest = $(this).data("name");    // destinataire
        var index = listeDestinataires.indexOf(dest);
        if(index != -1) listeDestinataires.splice(index, 1);
        miseEnFormeDestinataires();
        validationReferenceDevoir();
    });

    // Vidage destinataires
    $(document).on("click", ".viddestinataires", function(event){
        listeDestinataires = [];
        miseEnFormeDestinataires();
        validationReferenceDevoir();
    });

    // Validation et envoi du formulaire distribuer
    $(document).on("click", "#btnSubmitDistribuer", function(event){
        var validation = true;

        // Vérification de l'existence de la référence du document
        validation = validationReferenceDevoir() && validation;

        // Vérification de l'existence d'un groupe
        validation = validationDestinataire() && validation;

        // Vérification de l'existence d'un document
        validation = validationDocuments() && validation;

        // Envoi du formulaire
        $("html, body").animate({ scrollTop: 0 }, "slow");
        if (validation) {
            remplirModal();
            $('#recap').attr("style","left: 50%;").modal();     // Hack pour remettre la modal au bon endroit (classe modal) qui est initialisée à left = -500px
        }
    });

    // Confirmation depuis la modal
    $(document).on("click", "#recap-confirm", function(event){
        submitDistribuer();
        $('#recap').modal("hide");
    });

    // Envoi du formulaire ramasser
    $(document).on("click", "#btnSubmitRamasser", function(event){
        var refdev = $("option:selected", $("#list_dev_a_ram")).attr("label");
        if (refdev !== "(vide)") submitRamasser(refdev);
    });

    // Envoi du formulaire rendre
    $(document).on("click", "#btnSubmitRendre", function(event){
        var refdev = $("option:selected", $("#list_dev_a_ren")).attr("label");
        var group = $("option:selected", $("#list_dev_a_ren")).data("group");
        var envoimail = $("#ren_envoi_mail").prop("checked");
        var sujetmail = $("#ren_sujet_mail").prop("value");
        var corpsmail = $("#ren_corps_mail").prop("value");

        if (refdev !== "(vide)") submitRendre(refdev, group, envoimail, sujetmail, corpsmail);
    });

    // Vérification de l'existence de la référence du document
    $("#nomdev").on({blur : function(e){
        setTimeout(function(){validationReferenceDevoir();},50);
    }});

    // Vérification de la présence d'un destinataire
    $("#groupe").on({change : function(e){
        var destinataire = $("option:selected", $(this)).attr("label");
        if (listeDestinataires.indexOf(destinataire) == -1){
            listeDestinataires.push(destinataire);
            validationReferenceDevoir();
        }
        $("option:selected", $(this)).removeAttr("selected");  // vidage du destinataire
        $(this).trigger("liszt:updated");  // rafraichissement du plugin chosen
        miseEnFormeDestinataires();
        validationDestinataire();
    }});

    // Gestion du style pour le drag & drop
    $(".dropzone").on({
        dragover : function(e){
           $(this).addClass("hotDropzone");
        },
        dragleave : function(e){
           $(this).removeClass("hotDropzone");
        }
    });

    // Clic sur la case d'envoi de mail : affiche / masque les champs du mail
    $("#dist_envoi_mail").on({change : function(e){gestionActivationDistMail();}});

    // Clic sur la case d'envoi de mail : affiche / masque les champs du mail pour rendre
    $("#ren_envoi_mail").on({change : function(e){gestionActivationRenMail();}});

    // Objet plupload pour les devoirs
    var uploader_devoir = new plupload.Uploader({
        runtimes : "html5,html4",
        browse_button : "addtempdevoir",
        container: "containerdevoir",
        drop_element : "zonetempdevoir",
        multipart: true,
        multi_selection: true,
        urlstream_upload: true,
        multipart_params: {directory:"tmp"},
        max_file_size : max_upload_file_size,
        //chunk_size : "1mb",
        url : "documents/uploaddoctemp/devoir"
    });

    uploader_devoir.bind("Init", function(up, params) {
        // Si html5 est disponible on affiche la zone de drag & drop et on masque le bouton ajouter sinon c'est l'inverse
        if (params.runtime == "html5"){
            $("#parcourirtempdevoir").remove();
            $("#zonetempdevoir").show();
            uploader_devoir.settings.browse_button = "zonetempdevoir";
        }else{
            $("#zonetempdevoir").remove();
            $("#parcourirtempdevoir").show();
            uploader_devoir.settings.browse_button = "addtempdevoir";
        }
    });

    uploader_devoir.init();

    uploader_devoir.bind("FilesAdded", function(up, files) {
        var $listfich = $("#tempfichdevoir");
        $.each(files, function(i, file) {
            if (uploader_devoir.runtime == "html5"){ // la taille de fichier n'est pas connue en html4
                $listfich.prepend("<div id=\""+file.id+"\" class=\"file\">"+file.name+" ("+plupload.formatSize(file.size)+")"+"<div class=\"progress progress-striped active\"><div class=\"bar\"></div></div></div>");
            }else{
                $listfich.prepend("<div id=\""+file.id+"\" class=\"file\">"+file.name+" <div class=\"progress progress-striped active\"><div class=\"bar\"></div></div></div>");
            }
        });
        $(".dropzone").removeClass("hotDropzone");
        uploader_devoir.start();
    });

    uploader_devoir.bind("UploadProgress", function(up, file) {
        $("#"+file.id).find(".bar").css("width",file.percent+"%");
    });

    uploader_devoir.bind("Error", function(up, err) {
        var titrenotif = formatString(NOTIF_TITRE, "Document", "Erreur");
        afficherNotification("error", titrenotif, "Message: " + err.message + (err.file ? ", File: " + err.file.name : ""));
    });

    uploader_devoir.bind("FileUploaded", function(up, file) {
        $("#"+file.id).find(".bar").css("width","100%");
        var titrenotif = formatString(NOTIF_TITRE, "Document", "Ok");
        var textenotif = formatString(NOTIF_TEXTE, file.name);
        afficherNotification("info", titrenotif, textenotif);
        remplirFichTemp("devoir");
    });

    // Objet plupload pour les data
    var uploader_data = new plupload.Uploader({
        runtimes : "html5,html4",
        browse_button : "addtempdata",
        container: "containerdata",
        drop_element : "zonetempdata",
        multipart: true,
        urlstream_upload: true,
        multipart_params: {directory:"tmp"},
        max_file_size : max_upload_file_size,
        //chunk_size : "1mb",
        url : "documents/uploaddoctemp/data"
    });

    uploader_data.bind("Init", function(up, params) {
        // Si html5 est disponible on affiche la zone de drag & drop et on masque le bouton ajouter sinon c'est l'inverse
        if (params.runtime == "html5"){
            $("#parcourirtempdata").remove();
            $("#zonetempdata").show();
            uploader_data.settings.browse_button = "zonetempdata";
        }else{
            $("#zonetempdata").remove();
            $("#parcourirtempdata").show();
            uploader_data.settings.browse_button = "addtempdata";
        }
    });

    uploader_data.init();

    uploader_data.bind("FilesAdded", function(up, files) {
        var $listfich = $("#tempfichdata");
        $.each(files, function(i, file) {
            if (uploader_data.runtime == "html5"){ // la taille de fichier n'est pas connue en html4
                $listfich.prepend("<div id=\""+file.id+"\" class=\"file\">"+file.name+" ("+plupload.formatSize(file.size)+")"+"<div class=\"progress progress-striped active\"><div class=\"bar\"></div></div></div>");
            }else{
                $listfich.prepend("<div id=\""+file.id+"\" class=\"file\">"+file.name+" <div class=\"progress progress-striped active\"><div class=\"bar\"></div></div></div>");
            }
        });
        $(".dropzone").removeClass("hotDropzone");
        uploader_data.start();
    });

    uploader_data.bind("UploadProgress", function(up, file) {
        $("#"+file.id).find(".bar").css("width",file.percent+"%");
    });

    uploader_data.bind("Error", function(up, err) {
        var titrenotif = formatString(NOTIF_TITRE, "Données", "Erreur");
        afficherNotification("error", titrenotif, "Message: " + err.message + (err.file ? ", File: " + err.file.name : ""));
    });

    uploader_data.bind("FileUploaded", function(up, file) {
        $("#"+file.id).find(".bar").css("width","100%");
        var titrenotif = formatString(NOTIF_TITRE, "Données", "Ok");
        var textenotif = formatString(NOTIF_TEXTE, file.name);
        afficherNotification("info", titrenotif, textenotif);
        remplirFichTemp("data");
    });

    // popover permet l'affichage d'une popup pour les infobulle d'aide
    $("a[data-toggle=popover]").popover({html : true}).click(function(e) {e.preventDefault()});

    // Gestion des actions dans le tableau
    // Bouton Ramasser
    $(document).on("click", ".ramasser", function(event){
        var refdev = $(this).parents("tr").attr("data-name");
        if (refdev !== undefined) submitRamasser(refdev);
    });
    // Bouton Rendre
    $(document).on("click", ".rendre", function(event){
        var refdev = $(this).parents("tr").attr("data-name");
        if (refdev !== undefined) submitRendre(refdev);
    });
    // Bouton Supprimer
    $(document).on("click", ".supprimer", function(event){
        var refdev = $(this).parents("tr").attr("data-name");
        if (refdev !== undefined) submitSupprimer(refdev);
    });
});

function remplirGroupes() {
    // Appel ajax pour remplir la listes des groupes du serveur scribe
    ////{"matieres":["a-pla",...],"classes":["c31",...],"niveaux":["3eme",...],"groupes":["yo_grp",...],"equipes":["profs-c31",...]}
    $.getJSON("documents/rest/groupes", function(data) {
        var items = [];
        var listecle = $.map(data, function(value, key) {return key;}).sort(); // liste les clés du json et les trie
        $.each(listecle, function(i, cle) {
            if (data[cle].length != 0) {
                items.push("<optgroup label=\"" + cle[0].toUpperCase() + cle.substring(1) + "\">");
                $.each(data[cle], function(i, val) {
                    items.push("<option label=\"" + val + "\">" + val + "</option>");
                });
                items.push("</optgroup>");
            }
        });
        items.unshift("<option label=\"(vide)\"></option>"); // place une valeur vide au début
        $("#groupe").html(items.join(""));
        $("#groupe").attr("data-placeholder", " ");
        $("#groupe").chosen({ width: $("#groupe").css("width"), no_results_text: "Pas de résultats pour" });
    });
};

function remplirFichTemp(role) {
    // Appel ajax pour remplir les listes de fichiers téléchargés
    // role = "data" ou "devoir"
    ////{"listedoc":["yoyo2000.gif","1_005.png","yoyo2000.png"]}
    $.getJSON("documents/rest/listedoctemp/"+role, function(data) {
        var resultat = miseEnFormeFichTemp(data, role);
        if (resultat != "Aucun document"){
            $("#tempfichdevoir").removeClass("text-warning");
            $("#tempfichdevoir").siblings("span").removeClass("text-warning");
        }
        $("#tempfich"+role).html(resultat);
    });
};

function miseEnFormeFichTemp(data, role){
    // Prend en charge la liste des fichiers json (data) et retourne du html
    // role = "data" ou "devoir" pour l'inclure dans un attribut "data-role" récupérable en js
    // {"listedoc":["yoyo2000.gif","1_005.png","yoyo2000.png"]}
    if (data["listedoc"] == null) return "Aucun document";
    var items = [];
    $.each(data["listedoc"], function(i, fich) {
        items.push("<div class=\"well-small btn-group\">\n");
        items.push("<a class=\"btn btn-danger suptemp\" data-name=\"" + fich +"\" data-role=\"" + role + "\"><i class=\"icon-remove icon-white\"></i></a>\n");
        items.push("<a class=\"btn disabled\">" + fich +"</a>\n");
        items.push("</div>\n");
    });
    if (items.length !== 0) {
        items.unshift("<a class=\"btn-link pull-right vidtemp\" data-role=\""+ role +"\">Vider la liste</a>");
        return items.join("");
    }else{
        return "Aucun document";
    }
};

function remplirListDevRamasser() {
    // Appel ajax pour remplir la listes des devoirs à ramasser
    ////{"devoir-yo-2":{"groupe":"yo_grp","state":"dist","in_perso":true,"eleve_only":true},"devoir-yo-3":{"groupe":"yo_grp","state":"dist","in_perso":true,"eleve_only":true},...}
    $.getJSON("documents/rest/devoirs/aramasser", function(data) {
        $("#list_dev_a_ram").html(miseEnFormeDev(data));
        $("#list_dev_a_ram").attr("data-placeholder", " ");
        $("#list_dev_a_ram").chosen({ width: $("#list_dev_a_ram").css("width"), no_results_text: "Pas de résultats pour" });
        $("#list_dev_a_ram").trigger("liszt:updated");
    });
};

function remplirListDevRendre() {
    // Appel ajax pour remplir la listes des devoirs à rendre
    ////{"devoir-yo-4":{"groupe":"yo_grp","state":"ram","in_perso":true,"eleve_only":true},...}
    $.getJSON("documents/rest/devoirs/arendre", function(data) {
        $("#list_dev_a_ren").html(miseEnFormeDev(data));
        $("#list_dev_a_ren").attr("data-placeholder", " ");
        $("#list_dev_a_ren").chosen({ width: $("#list_dev_a_ren").css("width"), no_results_text: "Pas de résultats pour" });
        $("#list_dev_a_ren").trigger("liszt:updated");
    });
};

function miseEnFormeDev(data) {
    // Prend en charge une liste de devoirs en json (data) et retourne du html
    // {"devoir-yo-2":{"groupe":"yo_grp","state":"dist","in_perso":true,"eleve_only":true},"devoir-yo-3":{"groupe":"yo_grp","state":"dist","in_perso":true,"eleve_only":true},...}
    var items = [];
    var listecle = $.map(data, function(value, key) {return key;}).sort(); // liste les clés du json et les trie
    $.each(listecle, function(i, cle) {
        items.push("<option label=\"" + cle + "\" data-group=\"" + data[cle]["groupe"] + "\">" + cle + "</option>");
    });
    items.unshift("<option label=\"(vide)\"></option>"); // place une valeur vide au début
    return items.join("");
};

function miseEnFormeDestinataires(){
    // Prend en charge la liste des destinataires et retourne du html
    var resultat;
    var items = [];
    $.each(listeDestinataires, function(i, dest) {
        items.push("<div class=\"well-small btn-group\">\n");
        items.push("<a class=\"btn btn-danger supdestinataire\" data-name=\"" + dest + "\"><i class=\"icon-remove icon-white\"></i></a>\n");
        items.push("<a class=\"btn disabled\">" + dest +"</a>\n");
        items.push("</div>\n");
    });
    if (items.length !== 0) {
        items.unshift("<a class=\"btn-link pull-right viddestinataires\">Vider la liste</a>");
        resultat = items.join("");
    }else{
        resultat = "Aucun destinataire";
    }
    $("#tempdestinataire").html(resultat);
};

function remplirTableauHistorique() {
    // Rempli le tableau d'historique des devoirs avec 2 appels ajax (1 pour les devoirs à supprimer et 1 pour tous les devoirs)
    var listedev_asuppr = [];
    $.ajaxSetup({async:false})  // pour que l'appel ajax soit synchrone
    //{"DevoirsASupprimer": ['dev_yo2', 'dev_yo4', 'devoir-yo-2', 'devoir-yo-3']}
    $.getJSON("documents/rest/devoirs/asupprimer", function(data) {
        if (data["DevoirsASupprimer"] != null) {
            $.each(data["DevoirsASupprimer"], function(i, dev) {
                listedev_asuppr.push(dev);
            });
        }
    });
    $.ajaxSetup({async:true})  // pour remettre le comportement par défaut

    ////{"devoir-yo-2":{"groupe":"yo_grp","state":"dist","in_perso":true,"eleve_only":true},"devoir-yo-3":{"groupe":"yo_grp","state":"dist","in_perso":true,"eleve_only":true},...}
    $.getJSON("documents/rest/devoirs", function(data) {
        var items = [];
        var listecle = $.map(data, function(value, key) {return key;}).sort(); // liste les clés du json et les trie
        $.each(listecle, function(i, cle) {
            var infosdev = calculeinfosDevoir(data[cle]);
            if (listedev_asuppr.indexOf(cle) != -1){
                infosdev["action"] += " <a class=\"btn btn-danger supprimer\">Supprimer <i class=\"icon-remove icon-white\"></i></a>";
            }
            items.push("<tr class=\"" + infosdev["styledev"] + "\" data-name=\"" + cle + "\"><td>" + cle + "</td><td>" + data[cle]["groupe"] + "</td><td>" + infosdev["eleve_seul"] + "</td><td>" + infosdev["etat"] + "</td><td><p class=\"text-right\">" + infosdev["action"] + "</p></td>");
        });
        if (refTableau != 0) {
            // le tableau existait donc on le rafraichit
            $("#tableauhistorique").hide();
            refTableau.fnClearTable();
        }
        $("#tableauhistorique tbody").html(items.join(""));
        refTableau = $("#tableauhistorique").dataTable( {
            "bDestroy": true,
            ////"bRetrieve": true,
            "bAutoWidth": true,
            "bProcessing": true,
            "bStateSave" : true,
            "aaSorting": [[ 3, "asc" ]],
            "oLanguage": { "sUrl": "static/js/dataTables.txt" }
        } );
        $("#tableauhistorique").css("width", "100%");
        $("#tableauhistorique").show();
    });
};

function remplirModal(){
    var refdev = $("#nomdev").val();
    var eleve_only = $("#chxEleveOnly").find(":checked").val() == "eleve";
    var in_perso = $("#chxInPerso").find(":checked").val() == "perso";
    var envoimail = $("#dist_envoi_mail").prop("checked");
    var sujetmail = $("#dist_sujet_mail").prop("value");
    var corpsmail = $("#dist_corps_mail").prop("value");

    $("#recap-ref").html(refdev);
    var groupes = "";
    $.each(listeDestinataires, function(i, grp){
        groupes += '<button type="button" class="btn btn-default" disabled="disabled">'+grp+"</button>&nbsp;";
    });
    $("#recap-groupes").html(groupes);
    $("#recap-eleveonly").html(eleve_only ? "Uniquement aux élèves" : "À tous les membres");
    var $listeDevTemp = $("#tempfichdevoir a.disabled").filter("a");
    var devoirs = "";
    $.each($listeDevTemp, function(i, dev){
        devoirs += '<button type="button" class="btn btn-danger" disabled="disabled">'+dev.innerHTML+'</button>&nbsp;';
    });
    $("#recap-dev").html(devoirs);
    var $listeDataTemp = $("#tempfichdata a.disabled").filter("a");
    if ($listeDataTemp.length > 0){
    var datas = "";
    $.each($listeDataTemp, function(i, dat){
        datas += '<button type="button" class="btn btn-success" disabled="disabled">'+dat.innerHTML+'</button>&nbsp;';
        });
    $("#recap-data").html(datas);
    }
    else{
    $("#recap-data").html('aucun');
    }
    $("#recap-inperso").html(in_perso ? "Distribuer immédiatement" : "Distribuer plus tard");
    if (envoimail){
      $("#recap-envoimail").html('oui');
      $("#recap-sujet").html(sujetmail);
      $("#recap-mail").html(corpsmail);
    }
    else{
      $("#recap-envoimail").html('non');
      $("#recap-divmail").hide();
    }
};

function calculeinfosDevoir(devoir) {
    // Prend les données d'un devoir et retourne une liste d'infos calculées et du html
    // en entrée : {"groupe":"yo_grp","state":"dist","in_perso":true,"eleve_only":true}
    // en retour : []
    var infosdev = [];
    switch (devoir["state"]) {
        case "dist":
            infosdev["styledev"] = "info";
            infosdev["etat"] = "Distribué";
            infosdev["action"] = "<a class=\"btn btn-warning ramasser\">Ramasser <i class=\"icon-ok-sign icon-white\"></i></a>";
            break;
        case "ram":
            infosdev["styledev"] = "warning";
            infosdev["etat"] = "Ramassé";
            infosdev["action"] = "<a class=\"btn btn-success rendre\">Rendre <i class=\"icon-ok-sign icon-white\"></i></a>";
            break;
        case "ren":
            infosdev["styledev"] = "success";
            infosdev["etat"] = "Rendu";
            infosdev["action"] = "";
            break;
        default : break;
    }
    if (devoir["eleve_only"] == true){
        infosdev["eleve_seul"] = "oui";
    }else{
        infosdev["eleve_seul"] = "non";
    }
    return infosdev;
};

function afficherNotification(type, titre, texte, fixe) {
    // Affiche une notification avec le plugin jGrowl
    fixe = fixe || false; // si fixe n'est pas défini on le met à false
    var duree = 10000;     // en ms
    // style de boostrap (error, success, info, ou vide pour le style par défaut)
    var style = (type != "") ? "alert alert-block alert-" + type : "alert alert-block";
    if (fixe) {
        style += " opaque";
    }
    $.jGrowl.defaults.position = "bottom-right";   // initialisation de la position des notifications

    $.jGrowl(texte, {theme: style, life: duree, header: titre, sticky: fixe});
};

function formatString() {
    // Remplacement des chaines {x} (avec x à partir de 1)
    // 1er argument = le template de chaine
    // arguments suivants = les morceaux à remplacer
    // formatString("{1} c'est trop {2} !", "Ubuntu", "super") ==> "Ubuntu c'est trop super !"
    var args = [].slice.call(arguments);
    var pattern = new RegExp("{([1-" + args.length + "])}","g");
    return String(args[0]).replace(pattern, function(match, index) { return args[index]; });
}

function ajouterMessageValidation($element, message) {
    // Ajoute un message de validation au champ $element (= objet jquery)
    var elem_id = $element.attr("id");
    var $message = $("#" + elem_id + "_message");

    $element.closest("div.control-group").addClass("warning");
    if ($message.is("span")){
        $message.text(message);
    }else{
        $element.after("<span id=\"" + elem_id + "_message\" class=\"help-inline\">"+ message + "</span>");
    }
}

function supprimerMessageValidation($element) {
    // Supprime le message de validation du champ $element (= objet jquery)
    var elem_id = $element.attr("id");
    var $message = $("#" + elem_id + "_message");

    $element.closest("div.control-group").removeClass("warning");
    $message.remove();
}

function validationReferenceDevoir() {
    // Vérification de l'existence de la référence du document
    // Retourne false si la référence n'est pas fournie ou si elle est déjà utilisée
    var validation = true;
    var $elem = $("#nomdev");
    var refdev = $elem.val();

    if (refdev != ""){
        // Sécurisation de la reférence devoir
        $.ajaxSetup({async:false})  // pour que l'appel ajax soit synchrone
        $.getJSON("/documents/rest/secureref/"+refdev, function(data) {
            if (data["reload"] !== undefined) {
                rechargerPage(data["reload"]); // la session a été perdue donc on recharge
            }else{
                refdev = data["secureref"];
            }
        });

        // Récupération de la liste des devoirs
        var listedevoirs = [];
        $.getJSON("documents/rest/devoirs", function(data) {
            if (data["reload"] !== undefined) {
                rechargerPage(data["reload"]); // la session a été perdue donc on recharge
            }else{
                listedevoirs = $.map(data, function(value, key) {return key;}).sort(); // liste les clés du json et les trie
            }
        });
        $.ajaxSetup({async:true})  // pour remettre le comportement par défaut

        // Test de la référence du devoir avec comme suffixe le nom des groupes destinataires
        var groupes_interdits = "";
        $.each(listeDestinataires, function(i,dest){
            if (listedevoirs.indexOf(refdev+"-"+dest) != -1){
                groupes_interdits += ", " + dest;
            }
        });
        if (groupes_interdits.length > 0){
            validation = false;
            ajouterMessageValidation($elem, "Cette référence est déjà utilisée pour " + groupes_interdits.substr(2) + ".");
        }else{
            supprimerMessageValidation($elem);
        }
    }else{
        ajouterMessageValidation($elem, "Une référence doit être fournie.");
        validation = false;
    }
    return validation;
}

function validationDestinataire() {
    // Vérification de la présence d'un destinataire
    // Retourne false si aucun destinataire n'a été choisi
    var validation = true;
    var $elem = $("#tempdestinataire");
    if (listeDestinataires.length == 0){
        $elem.addClass("text-warning");
        $("#lbldest").addClass("text-warning");
        validation = false;
    }else{
        $elem.removeClass("text-warning");
        $("#lbldest").removeClass("text-warning");
    }
    return validation;
}

function validationDocuments() {
    // Vérification de la présence de document
    // Retourne false si aucun document n'a été envoyé
    var validation = true;
    var $elem = $("#tempfichdevoir");
    if ($elem.text() == "Aucun document"){
        $elem.addClass("text-warning");
        $elem.siblings("span").addClass("text-warning");
        validation = false;
    }else{
        $elem.removeClass("text-warning");
        $elem.siblings("span").removeClass("text-warning");
    }
    return validation;
}

function submitRamasser(refdev) {
    $("body").addClass("wait");
    $.getJSON("documents/rest/devoirs/ramasser/" + refdev, function(data) {
        // Exemple de retour json : {"ramasser": "Le devoir a été ramassé."}
        // ou en cas d'erreur : {"erreur": "Une erreur est survenue lors du ramassage."}
        if (data["reload"] !== undefined) {
            rechargerPage(data["reload"]); // la session a été perdue donc on recharge
        }else if (data["erreur"] === undefined){
            remplirTableauHistorique();
            afficherNotification("success", "Ramassage", data["ramasser"]);
            remplirListDevRamasser();
            remplirListDevRendre();
        }else{
            afficherNotification("error", "Erreur", data["erreur"]);
        }
        $("body").removeClass("wait");
    });
}

function submitRendre(refdev, group, envoimail, sujetmail, corpsmail) {
    $("body").addClass("wait");
    if(!envoimail) envoimail = "false";
    if(!group) group = "";
    if(!sujetmail) sujetmail = "";
    if(!corpsmail) corpsmail = "";

    $.ajax({
        type: "POST",
        url: "documents/rest/devoirs/rendre",
        data: {"nomdev":refdev, "groupe":group, "envoimail":envoimail, "sujetmail":sujetmail, "corpsmail":corpsmail},
        success: function (data) {
            //  Exemple de retour json : {"rendre": "Le devoir a été rendu."}
            // ou en cas d'erreur : {"erreur": "Une erreur est survenue lors du rendu."}
            if (data["reload"] !== undefined) {
                rechargerPage(data["reload"]); // la session a été perdue donc on recharge
            }else if (data["erreur"] === undefined){
                remplirTableauHistorique();
                afficherNotification("success", "Rendu", data["rendre"]);
                remplirListDevRendre();
            }else{
                afficherNotification("error", "Erreur", data["erreur"]);
            }
            $("body").removeClass("wait");
        },
        error : function (data) {
            afficherNotification("error", "Erreur", "Impossible de contacter le serveur.");
            $("body").removeClass("wait");
        }
    });
}

function submitSupprimer(refdev) {
    $("body").addClass("wait");
    $.getJSON("documents/rest/devoirs/supprimer/" + refdev, function(data) {
        // Exemple de retour json : {"supprimer": "Le devoir a été nettoyé."}
        // ou en cas d'erreur : {"erreur": "Une erreur est survenue lors du nettoyage."}
        if (data["reload"] !== undefined) {
            rechargerPage(data["reload"]); // la session a été perdue donc on recharge
        }else if (data["erreur"] === undefined){
            remplirTableauHistorique();
            afficherNotification("success", "Suppression", data["supprimer"]);
        }else{
            afficherNotification("error", "Erreur", data["erreur"]);
        }
        $("body").removeClass("wait");
    });
}

function rechargerPage(message){
    afficherNotification("error", "Erreur", message);
    window.location.reload();
}

function gestionActivationDistMail(){
    // Active ou désactive les champs de saisie du mail
    if ($("#dist_envoi_mail").prop('checked')){
        $("#dist_sujet_mail").parents(".control-group").show("slow");
        $("#dist_corps_mail").parents(".control-group").show("slow");
    }else{
        $("#dist_sujet_mail").parents(".control-group").hide("slow");
        $("#dist_corps_mail").parents(".control-group").hide("slow");
    }
}

function gestionActivationRenMail(){
    // rempli les valeurs par défaut des champs sujet et corps de mail
    if ($("#ren_envoi_mail").prop('checked')){
        $("#ren_sujet_mail").parents(".control-group").show("slow");
        $("#ren_corps_mail").parents(".control-group").show("slow");
    }else{
        $("#ren_sujet_mail").parents(".control-group").hide("slow");
        $("#ren_corps_mail").parents(".control-group").hide("slow");
    }
}

function submitDistribuer() {
    $("body").addClass("wait");
    var refdev = $("#nomdev").val();
    var eleve_only = String($("#chxEleveOnly").find(":checked").val() == "eleve");
    var in_perso = String($("#chxInPerso").find(":checked").val() == "perso");
    var envoimail = $("#dist_envoi_mail").prop("checked");
    var sujetmail = $("#dist_sujet_mail").prop("value");
    var corpsmail = $("#dist_corps_mail").prop("value");

    $.ajax({
        type: "POST",
        url: "documents",
        data: {"groupes":JSON.stringify(listeDestinataires), "nomdev":refdev, "eleve_only":eleve_only, "in_perso":in_perso, "envoimail":envoimail, "sujetmail":sujetmail, "corpsmail":corpsmail},
        success: function (data) {
            // Exemple de retour json : {"c31": {"rate": [], "réussi": 8, "devoir": "dev-c31"}, "c43": {"rate": [], "réussi": 5, "devoir": "dev-c43"}}
            if (data["reload"] !== undefined) {
                rechargerPage(data["reload"]); // la session a été perdue donc on recharge
            }else if (data["erreur"] === undefined){
                // pour chaque groupe distribué
                $.each(data, function(groupe, resultat){
                    if (resultat["rate"].length == 0){
                        // tout s'est bien passé
                        var devoirnotif = formatString(NOTIF_DEVOIR, resultat["devoir"], resultat["réussi"]);
                        afficherNotification("success", "Distribution d'un devoir", devoirnotif);
                    }else{
                        // il y a eu des erreurs de copie de devoir
                        var devoirerrnotif = formatString(NOTIF_DEVOIR_ERR, resultat["devoir"], resultat["réussi"], resultat["rate"].join(', '));
                        afficherNotification("warning", "Distribution d'un devoir", devoirerrnotif);
                    }
                });

                remplirListDevRamasser();
                remplirTableauHistorique();
                $("#nomdev").val("");   // vidage du champ référence
                listeDestinataires = []; // vidage destinataires
                miseEnFormeDestinataires();
                remplirFichTemp("devoir");
                remplirFichTemp("data");
            }else{
                afficherNotification("error", "Erreur", data["erreur"]);
            }
            $("body").removeClass("wait");
        },
        error : function (data) {
            afficherNotification("error", "Erreur", "Impossible de contacter le serveur.");
            $("body").removeClass("wait");
        }
    });
};

})();    // fin wrapper javascript